import { Collection, Identifier, JSCodeshift, MemberExpression } from "jscodeshift";

import { getV2ClientNewExpression } from "../utils";

export const getV2ClientNamesFromNewExpr = (
  j: JSCodeshift,
  source: Collection<unknown>,
  v2GlobalName: string
): string[] =>
  source
    .find(j.NewExpression, getV2ClientNewExpression({ v2GlobalName }))
    .nodes()
    .map(
      (newExpression) => ((newExpression.callee as MemberExpression).property as Identifier).name
    );
